package demo;

/**
 * Interface for classes that need to track their state.
 */
public interface IStateMachine {
  /**
   * Sets the state of the object to the given state along with any data associated with the transition.  Assumes that states are represented by integer values (like STATE_1, STATE_2, etc.).
   */
   public void setCurrentState(int newState, Object eventData);
}
